package server

import (
	"strconv"

	"git.pbiernat.dev/egommerce/pricing-service/internal/app/service"
	"git.pbiernat.dev/egommerce/pricing-service/internal/app/ui"
	"github.com/gofiber/fiber/v2"
)

func (s *Server) GetProductPriceHandler(c *fiber.Ctx) error {
	prodID, err := strconv.Atoi(c.Params("id"))
	if err != nil {
		return s.Error400(c, err.Error())
	}

	priceSrv := service.NewPriceService(s.db, s.cache, s.ebCh, s.log)
	res, err := ui.GetProductPrice(priceSrv, prodID)
	if err != nil {
		s.log.Log("GetProductPriceHandler error: ", err)
		return s.Error404(c, "Product not found")
	}

	return c.JSON(res)
}
